VERSION 5.00
Begin VB.UserControl SpinPart1 
   CanGetFocus     =   0   'False
   ClientHeight    =   615
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   615
   BeginProperty Font 
      Name            =   "Webdings"
      Size            =   9.75
      Charset         =   2
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ScaleHeight     =   41
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   41
   Begin VB.Line B 
      BorderColor     =   &H80000010&
      X1              =   0
      X2              =   32
      Y1              =   32
      Y2              =   32
   End
   Begin VB.Line T 
      BorderColor     =   &H80000004&
      X1              =   0
      X2              =   32
      Y1              =   0
      Y2              =   0
   End
   Begin VB.Line R 
      BorderColor     =   &H80000010&
      X1              =   32
      X2              =   32
      Y1              =   0
      Y2              =   32
   End
   Begin VB.Line L 
      BorderColor     =   &H80000004&
      X1              =   0
      X2              =   0
      Y1              =   0
      Y2              =   32
   End
End
Attribute VB_Name = "SpinPart1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim Pushed As Boolean
'Default Property Values:
Const m_def_Caption = "5"
Const m_def_Color1 = vbWhite
Const m_def_Color2 = vbButtonShadow
'Property Variables:
Dim m_Caption As String
Dim m_Color1 As OLE_COLOR
Dim m_Color2 As OLE_COLOR

Dim lButton As Integer, lX As Single, lY As Single
Event Click()
Event Holding(Value As Boolean)
Event Hold()
Event Release()

Private Sub PrintCaption()
    UserControl.Cls
    UserControl.CurrentX = (UserControl.ScaleWidth - UserControl.TextWidth(m_Caption)) \ 2
    UserControl.CurrentY = (UserControl.ScaleHeight - UserControl.TextHeight(m_Caption)) \ 2
    UserControl.Print m_Caption
End Sub

Private Sub Reposition()
    L.Y2 = UserControl.ScaleHeight
    T.X2 = UserControl.ScaleWidth
    R.X1 = UserControl.ScaleWidth - 1
    R.X2 = UserControl.ScaleWidth - 1
    R.Y2 = UserControl.ScaleHeight
    B.Y1 = UserControl.ScaleHeight - 1
    B.Y2 = UserControl.ScaleHeight - 1
    B.X2 = UserControl.ScaleWidth
    Pop
    PrintCaption
End Sub

Private Sub Push()
    L.BorderColor = m_Color2
    T.BorderColor = m_Color2
    R.BorderColor = m_Color1
    B.BorderColor = m_Color1
    Pushed = True
End Sub

Private Sub Pop()
    L.BorderColor = m_Color1
    T.BorderColor = m_Color1
    R.BorderColor = m_Color2
    B.BorderColor = m_Color2
    Pushed = False
End Sub

Private Sub UserControl_DblClick()
    UserControl_MouseDown lButton, 0, lX, lY
End Sub

Private Sub UserControl_Initialize()
    UserControl.ScaleMode = vbPixels
    UserControl.AutoRedraw = True
End Sub

Private Sub UserControl_InitProperties()
    m_Color1 = m_def_Color1
    m_Color2 = m_def_Color2
    m_Caption = m_def_Caption
    Reposition
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    lButton = Button
    lX = X
    lY = Y
    If Button = 1 Then
        If Not Pushed Then Push
        DoEvents
        RaiseEvent Hold
        RaiseEvent Holding(True)
    End If
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 1 Then
        If X >= 0 And X < UserControl.ScaleWidth And Y >= 0 And Y < UserControl.ScaleHeight Then
            If Not Pushed Then Push
            DoEvents
            RaiseEvent Holding(True)
        Else
            If Pushed Then Pop
            DoEvents
            RaiseEvent Holding(False)
        End If
    End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 1 Then
        Pop
        If X >= 0 And X < UserControl.ScaleWidth And Y >= 0 And Y < UserControl.ScaleHeight Then RaiseEvent Click
        DoEvents
        RaiseEvent Holding(False)
        RaiseEvent Release
    End If
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    UserControl.ForeColor = PropBag.ReadProperty("ForeColor", &H80000012)
    m_Color1 = PropBag.ReadProperty("Color1", m_def_Color1)
    m_Color2 = PropBag.ReadProperty("Color2", m_def_Color2)
    m_Caption = PropBag.ReadProperty("Caption", m_def_Caption)
    Reposition
End Sub

Private Sub UserControl_Resize()
    Dim w As Boolean, h As Boolean
    UserControl.FontSize = 20
    Do
        UserControl.FontSize = UserControl.FontSize - 1
        w = UserControl.ScaleWidth * 3 / 4 < UserControl.TextWidth(m_Caption)
        h = UserControl.ScaleHeight * 4 / 3 < UserControl.TextHeight(m_Caption)
        DoEvents
    Loop While w Or h
    Reposition
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
    PrintCaption
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = UserControl.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    UserControl.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
    PrintCaption
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get Color1() As OLE_COLOR
    Color1 = m_Color1
End Property

Public Property Let Color1(ByVal New_Color1 As OLE_COLOR)
    m_Color1 = New_Color1
    PropertyChanged "Color1"
    Pop
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get Color2() As OLE_COLOR
    Color2 = m_Color2
End Property

Public Property Let Color2(ByVal New_Color2 As OLE_COLOR)
    m_Color2 = New_Color2
    PropertyChanged "Color2"
    Pop
End Property

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, &H80000012)
    Call PropBag.WriteProperty("Color1", m_Color1, m_def_Color1)
    Call PropBag.WriteProperty("Color2", m_Color2, m_def_Color2)
    Call PropBag.WriteProperty("Caption", m_Caption, m_def_Caption)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,
Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/sets the text displayed in an object's title bar or below an object's icon."
Attribute Caption.VB_UserMemId = -518
    Caption = m_Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    m_Caption = New_Caption
    PropertyChanged "Caption"
    PrintCaption
End Property
