VERSION 5.00
Begin VB.UserControl MMZ_Spin 
   CanGetFocus     =   0   'False
   ClientHeight    =   705
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   720
   ScaleHeight     =   47
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   48
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   50
      Left            =   120
      Top             =   240
   End
   Begin Project1.SpinPart1 cmdUp 
      Height          =   180
      Left            =   0
      Top             =   0
      Width           =   375
      _ExtentX        =   661
      _ExtentY        =   318
   End
   Begin Project1.SpinPart1 cmdDown 
      Height          =   180
      Left            =   0
      Top             =   195
      Width           =   375
      _ExtentX        =   661
      _ExtentY        =   318
      Caption         =   "6"
   End
End
Attribute VB_Name = "MMZ_Spin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit
Public Enum OrientationConstants
    Vertical = 0
    Horizontal = 1
End Enum
'Default Property Values:
Const m_def_Delay = 500
Const m_def_Speed = 25
Const m_def_Orientation = 0
Const m_def_RightToLeft = True
Const m_def_BackColor = vbButtonFace
Const m_def_Color1 = vbWhite
Const m_def_Color2 = vbButtonShadow
Const m_def_ForeColor = 0
Const m_def_Max = 100
Const m_def_Min = 0
Const m_def_Infinity = False
Const m_def_SmallChange = 1
'Property Variables:
Dim m_Delay As Integer
Dim m_Speed As Integer
Dim m_Orientation As OrientationConstants
Dim m_RightToLeft As Boolean
Dim m_Obj As Object
Dim m_BackColor As OLE_COLOR
Dim m_Color1 As OLE_COLOR
Dim m_Color2 As OLE_COLOR
Dim m_ForeColor As OLE_COLOR
Dim m_Max As Single
Dim m_Min As Single
Dim m_Infinity As Boolean
Dim m_SmallChange As Single
Dim LastBring As String

Dim Counter As Long
Dim Cmd1 As Boolean

Public Sub Grow()
    On Error Resume Next
    If TypeOf m_Obj Is TextBox Then
        If Not m_Infinity And Val(m_Obj.Text) + m_SmallChange >= m_Max Then
            m_Obj.Text = Max
        Else
            m_Obj.Text = Val(m_Obj.Text) + m_SmallChange
        End If
    End If
End Sub

Public Sub Shrink()
    On Error Resume Next
    If TypeOf Obj Is TextBox Then
        If Not m_Infinity And Val(Obj.Text) - m_SmallChange <= Min Then
            Obj.Text = Min
        Else
            Obj.Text = Val(Obj.Text) - m_SmallChange
        End If
    End If
End Sub

Private Sub cmdUp_Hold()
    Cmd1 = True
    Grow
    Timer1_Timer
End Sub

Private Sub cmdUp_Holding(Value As Boolean)
    Timer1 = Value
End Sub

Private Sub cmdUp_Release()
    Timer1 = False
    Counter = 0
End Sub

Private Sub cmdDown_Hold()
    Cmd1 = False
    Shrink
    Timer1_Timer
End Sub

Private Sub cmdDown_Holding(Value As Boolean)
    Timer1 = Value
End Sub

Private Sub cmdDown_Release()
    Timer1 = False
    Counter = 0
End Sub
    
Private Sub Timer1_Timer()
    Counter = Counter + 1
    Timer1.Interval = IIf(Counter = 1, m_Delay, m_Speed)
    If Counter > 1 Then If Cmd1 Then Grow Else Shrink
End Sub

Private Sub UserControl_Resize()
    If m_Orientation = Vertical Then
        cmdUp.Height = UserControl.ScaleHeight \ 2
        cmdUp.Width = UserControl.ScaleWidth
        cmdUp.Move 0, 0
        cmdDown.Height = UserControl.ScaleHeight \ 2
        cmdDown.Width = UserControl.ScaleWidth
        cmdDown.Move 0, UserControl.ScaleHeight - cmdDown.Height
    Else
        If m_RightToLeft Then
            cmdUp.Height = UserControl.ScaleHeight
            cmdUp.Width = UserControl.ScaleWidth \ 2
            cmdUp.Move UserControl.ScaleWidth - cmdUp.Width, 0
            cmdDown.Height = UserControl.ScaleHeight
            cmdDown.Width = UserControl.ScaleWidth \ 2
            cmdDown.Move 0, 0
        Else
            cmdUp.Height = UserControl.ScaleHeight
            cmdUp.Width = UserControl.ScaleWidth \ 2
            cmdUp.Move 0, 0
            cmdDown.Height = UserControl.ScaleHeight
            cmdDown.Width = UserControl.ScaleWidth \ 2
            cmdDown.Move UserControl.ScaleWidth - cmdDown.Width, 0
        End If
    End If
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get ForeColor() As OLE_COLOR
    ForeColor = m_ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    m_ForeColor = New_ForeColor
    PropertyChanged "ForeColor"
    cmdUp.ForeColor = m_ForeColor
    cmdDown.ForeColor = m_ForeColor
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=12,0,0,0
Public Property Get Max() As Single
    Max = m_Max
End Property

Public Property Let Max(ByVal New_Max As Single)
    m_Max = New_Max
    PropertyChanged "Max"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=12,0,0,0
Public Property Get Min() As Single
    Min = m_Min
End Property

Public Property Let Min(ByVal New_Min As Single)
    m_Min = New_Min
    PropertyChanged "Min"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,0
Public Property Get Infinity() As Boolean
Attribute Infinity.VB_Description = "Accept or reject Max and Min"
    Infinity = m_Infinity
End Property

Public Property Let Infinity(ByVal New_Infinity As Boolean)
    m_Infinity = New_Infinity
    PropertyChanged "Infinity"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=12,0,0,0
Public Property Get SmallChange() As Single
    SmallChange = m_SmallChange
End Property

Public Property Let SmallChange(ByVal New_SmallChange As Single)
    m_SmallChange = New_SmallChange
    PropertyChanged "SmallChange"
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_ForeColor = Ambient.ForeColor
    m_Max = m_def_Max
    m_Min = m_def_Min
    m_Infinity = m_def_Infinity
    m_SmallChange = m_def_SmallChange
    m_BackColor = Ambient.BackColor
    m_Color1 = m_def_Color1
    m_Color2 = m_def_Color2
    m_RightToLeft = m_def_RightToLeft
    cmdUp.Color1 = m_Color1
    cmdDown.Color1 = m_Color1
    cmdUp.Color2 = m_Color2
    cmdDown.Color2 = m_Color2
    cmdUp.ForeColor = m_ForeColor
    cmdDown.ForeColor = m_ForeColor
    cmdUp.BackColor = m_BackColor
    cmdDown.BackColor = m_BackColor
    m_Orientation = m_def_Orientation
    SetCaption
    m_Delay = m_def_Delay
    m_Speed = m_def_Speed
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_ForeColor = PropBag.ReadProperty("ForeColor", Ambient.ForeColor)
    m_Max = PropBag.ReadProperty("Max", m_def_Max)
    m_Min = PropBag.ReadProperty("Min", m_def_Min)
    m_Infinity = PropBag.ReadProperty("Infinity", m_def_Infinity)
    m_SmallChange = PropBag.ReadProperty("SmallChange", m_def_SmallChange)
    m_BackColor = PropBag.ReadProperty("BackColor", Ambient.BackColor)
    m_Color1 = PropBag.ReadProperty("Color1", m_def_Color1)
    m_Color2 = PropBag.ReadProperty("Color2", m_def_Color2)
    Set m_Obj = PropBag.ReadProperty("OBJ", Nothing)
    m_RightToLeft = PropBag.ReadProperty("RightToLeft", m_def_RightToLeft)
    cmdUp.Color1 = m_Color1
    cmdDown.Color1 = m_Color1
    cmdUp.Color2 = m_Color2
    cmdDown.Color2 = m_Color2
    cmdUp.ForeColor = m_ForeColor
    cmdDown.ForeColor = m_ForeColor
    cmdUp.BackColor = m_BackColor
    cmdDown.BackColor = m_BackColor
    m_Orientation = PropBag.ReadProperty("Orientation", m_def_Orientation)
    SetCaption
    UserControl_Resize
    m_Delay = PropBag.ReadProperty("Delay", m_def_Delay)
    m_Speed = PropBag.ReadProperty("Speed", m_def_Speed)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("ForeColor", m_ForeColor, Ambient.ForeColor)
    Call PropBag.WriteProperty("Max", m_Max, m_def_Max)
    Call PropBag.WriteProperty("Min", m_Min, m_def_Min)
    Call PropBag.WriteProperty("Infinity", m_Infinity, m_def_Infinity)
    Call PropBag.WriteProperty("SmallChange", m_SmallChange, m_def_SmallChange)
    Call PropBag.WriteProperty("BackColor", m_BackColor, Ambient.BackColor)
    Call PropBag.WriteProperty("Color1", m_Color1, m_def_Color1)
    Call PropBag.WriteProperty("Color2", m_Color2, m_def_Color2)
    Call PropBag.WriteProperty("RightToLeft", m_RightToLeft, m_def_RightToLeft)
    Call PropBag.WriteProperty("Orientation", m_Orientation, m_def_Orientation)
    Call PropBag.WriteProperty("Delay", m_Delay, m_def_Delay)
    Call PropBag.WriteProperty("Speed", m_Speed, m_def_Speed)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get BackColor() As OLE_COLOR
    BackColor = m_BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    m_BackColor = New_BackColor
    PropertyChanged "BackColor"
    cmdUp.BackColor = m_BackColor
    cmdDown.BackColor = m_BackColor
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get Color1() As OLE_COLOR
    Color1 = m_Color1
End Property

Public Property Let Color1(ByVal New_Color1 As OLE_COLOR)
    m_Color1 = New_Color1
    PropertyChanged "Color1"
    cmdUp.Color1 = m_Color1
    cmdDown.Color1 = m_Color1
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get Color2() As OLE_COLOR
    Color2 = m_Color2
End Property

Public Property Let Color2(ByVal New_Color2 As OLE_COLOR)
    m_Color2 = New_Color2
    PropertyChanged "Color2"
    cmdUp.Color2 = m_Color2
    cmdDown.Color2 = m_Color2
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=9,0,0,0
Public Property Get Obj() As Object
    Set Obj = m_Obj
End Property

Public Property Set Obj(ByVal New_Obj As Object)
    Dim vLeft As Single
    Set m_Obj = New_Obj
    PropertyChanged "OBJ"
    Extender.Height = Obj.Height
    vLeft = IIf(m_RightToLeft, Obj.Left + Obj.Width, Obj.Left - Extender.Width)
    Extender.Move vLeft, Obj.Top + (Obj.Height - Extender.Height) \ 2
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,0
Public Property Get RightToLeft() As Boolean
    RightToLeft = m_RightToLeft
End Property

Public Property Let RightToLeft(ByVal New_RightToLeft As Boolean)
    m_RightToLeft = New_RightToLeft
    PropertyChanged "RightToLeft"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14,0,0,0
Public Property Get Orientation() As OrientationConstants
    Orientation = m_Orientation
End Property

Public Property Let Orientation(ByVal New_Orientation As OrientationConstants)
    m_Orientation = New_Orientation
    PropertyChanged "Orientation"
    SetCaption
    UserControl_Resize
End Property

Private Sub SetCaption()
    If m_Orientation = Vertical Then
        cmdUp.Caption = "5"
        cmdDown.Caption = "6"
    Else
        If m_RightToLeft Then
            cmdUp.Caption = "4"
            cmdDown.Caption = "3"
        Else
            cmdUp.Caption = "3"
            cmdDown.Caption = "4"
        End If
    End If
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get Delay() As Integer
    Delay = m_Delay
End Property

Public Property Let Delay(ByVal New_Delay As Integer)
    m_Delay = New_Delay
    PropertyChanged "Delay"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,0,0,0
Public Property Get Speed() As Integer
    Speed = m_Speed
End Property

Public Property Let Speed(ByVal New_Speed As Integer)
    m_Speed = New_Speed
    PropertyChanged "Speed"
End Property

